"use strict";module.exports=parse,parse.filename=null,parse.defaults={keepCase:!1};var tokenize=require("./tokenize"),Root=require("./root"),Type=require("./type"),Field=require("./field"),MapField=require("./mapfield"),OneOf=require("./oneof"),Enum=require("./enum"),Service=require("./service"),Method=require("./method"),types=require("./types"),util=require("./util"),base10Re=/^[1-9][0-9]*$/,base10NegRe=/^-?[1-9][0-9]*$/,base16Re=/^0[x][0-9a-fA-F]+$/,base16NegRe=/^-?0[x][0-9a-fA-F]+$/,base8Re=/^0[0-7]+$/,base8NegRe=/^-?0[0-7]+$/,numberRe=/^(?![eE])[0-9]*(?:\.[0-9]*)?(?:[eE][+-]?[0-9]+)?$/,nameRe=/^[a-zA-Z_][a-zA-Z_0-9]*$/,typeRefRe=/^(?:\.?[a-zA-Z_][a-zA-Z_0-9]*)(?:\.[a-zA-Z_][a-zA-Z_0-9]*)*$/,fqTypeRefRe=/^(?:\.[a-zA-Z_][a-zA-Z_0-9]*)+$/;function parse(e,t,n){t instanceof Root||(n=t,t=new Root),n||(n=parse.defaults);var r,a,o,i,s,f=n.preferTrailingComment||!1,c=tokenize(e,n.alternateCommentMode||!1),u=c.next,p=c.push,l=c.peek,d=c.skip,h=c.cmnt,m=!0,w=!1,v=t,R=n.keepCase?function(e){return e}:util.camelCase;function b(e,t,n){var r=parse.filename;return n||(parse.filename=null),Error("illegal "+(t||"token")+" '"+e+"' ("+(r?r+", ":"")+"line "+c.line+")")}function k(){var e,t=[];do{if('"'!==(e=u())&&"'"!==e)throw b(e);t.push(u()),d(e),e=l()}while('"'===e||"'"===e);return t.join("")}function y(e){var t=u();switch(t){case"'":case'"':return p(t),k();case"true":case"TRUE":return!0;case"false":case"FALSE":return!1}try{return function(e,t){var n=1;switch("-"===e.charAt(0)&&(n=-1,e=e.substring(1)),e){case"inf":case"INF":case"Inf":return 1/0*n;case"nan":case"NAN":case"Nan":case"NaN":return NaN;case"0":return 0}if(base10Re.test(e))return n*parseInt(e,10);if(base16Re.test(e))return n*parseInt(e,16);if(base8Re.test(e))return n*parseInt(e,8);if(numberRe.test(e))return n*parseFloat(e);throw b(e,"number",t)}(t,!0)}catch(n){if(e&&typeRefRe.test(t))return t;throw b(t,"value")}}function g(e,t){do t&&('"'===(n=l())||"'"===n)?e.push(k()):e.push([r=q(u()),d("to",!0)?q(u()):r]);while(d(",",!0));var n,r,a={options:void 0};a.setOption=function(e,t){void 0===this.options&&(this.options={}),this.options[e]=t},x(a,function(e){if("option"===e)F(a,e),d(";");else throw b(e)},function(){$(a)})}function q(e,t){switch(e){case"max":case"MAX":case"Max":return 0x1fffffff;case"0":return 0}if(!t&&"-"===e.charAt(0))throw b(e,"id");if(base10NegRe.test(e))return parseInt(e,10);if(base16NegRe.test(e))return parseInt(e,16);if(base8NegRe.test(e))return parseInt(e,8);throw b(e,"id")}function A(e,t){switch(t){case"option":return F(e,t),d(";"),!0;case"message":return N(e,t),!0;case"enum":return _(e,t),!0;case"service":return function(e,t){if(!nameRe.test(t=u()))throw b(t,"service name");var n=new Service(t);x(n,function(e){if(!A(n,e)){if("rpc"===e)(function(e,t){var n=h(),r=t;if(!nameRe.test(t=u()))throw b(t,"name");var a,o,i,s,f=t;if(d("("),d("stream",!0)&&(o=!0),!typeRefRe.test(t=u())||(a=t,d(")"),d("returns"),d("("),d("stream",!0)&&(s=!0),!typeRefRe.test(t=u())))throw b(t);i=t,d(")");var c=new Method(f,r,a,i,o,s);c.comment=n,x(c,function(e){if("option"===e)F(c,e),d(";");else throw b(e)}),e.add(c)})(n,e);else throw b(e)}}),e.add(n)}(e,t),!0;case"extend":return function(e,t){if(!typeRefRe.test(t=u()))throw b(t,"reference");var n=t;x(null,function(t){switch(t){case"required":case"repeated":O(e,t,n);break;case"optional":w?O(e,"proto3_optional",n):O(e,"optional",n);break;default:if(!w||!typeRefRe.test(t))throw b(t);p(t),O(e,"optional",n)}})}(e,t),!0}return!1}function x(e,t,n){var r,a=c.line;if(e&&("string"!=typeof e.comment&&(e.comment=h()),e.filename=parse.filename),d("{",!0)){for(;"}"!==(r=u());)t(r);d(";",!0)}else n&&n(),d(";"),e&&("string"!=typeof e.comment||f)&&(e.comment=h(a)||e.comment)}function N(e,t){if(!nameRe.test(t=u()))throw b(t,"type name");var n=new Type(t);x(n,function(e){if(!A(n,e))switch(e){case"map":(function(e){d("<");var t=u();if(void 0===types.mapKey[t])throw b(t,"type");d(",");var n=u();if(!typeRefRe.test(n))throw b(n,"type");d(">");var r=u();if(!nameRe.test(r))throw b(r,"name");d("=");var a=new MapField(R(r),q(u()),t,n);x(a,function(e){if("option"===e)F(a,e),d(";");else throw b(e)},function(){$(a)}),e.add(a)})(n,e);break;case"required":case"repeated":O(n,e);break;case"optional":w?O(n,"proto3_optional"):O(n,"optional");break;case"oneof":(function(e,t){if(!nameRe.test(t=u()))throw b(t,"name");var n=new OneOf(R(t));x(n,function(e){"option"===e?(F(n,e),d(";")):(p(e),O(n,"optional"))}),e.add(n)})(n,e);break;case"extensions":g(n.extensions||(n.extensions=[]));break;case"reserved":g(n.reserved||(n.reserved=[]),!0);break;default:if(!w||!typeRefRe.test(e))throw b(e);p(e),O(n,"optional")}}),e.add(n)}function O(e,t,n){var r=u();if("group"===r){!function(e,t){var n=u();if(!nameRe.test(n))throw b(n,"name");var r=util.lcFirst(n);n===r&&(n=util.ucFirst(n)),d("=");var a=q(u()),o=new Type(n);o.group=!0;var i=new Field(r,a,n,t);i.filename=parse.filename,x(o,function(e){switch(e){case"option":F(o,e),d(";");break;case"required":case"repeated":O(o,e);break;case"optional":w?O(o,"proto3_optional"):O(o,"optional");break;case"message":N(o,e);break;case"enum":_(o,e);break;default:throw b(e)}}),e.add(o).add(i)}(e,t);return}for(;r.endsWith(".")||l().startsWith(".");)r+=u();if(!typeRefRe.test(r))throw b(r,"type");var a=u();if(!nameRe.test(a))throw b(a,"name");a=R(a),d("=");var o=new Field(a,q(u()),r,t,n);if(x(o,function(e){if("option"===e)F(o,e),d(";");else throw b(e)},function(){$(o)}),"proto3_optional"===t){var i=new OneOf("_"+a);o.setOption("proto3_optional",!0),i.add(o),e.add(i)}else e.add(o);!w&&o.repeated&&(void 0!==types.packed[r]||void 0===types.basic[r])&&o.setOption("packed",!1,!0)}function _(e,t){if(!nameRe.test(t=u()))throw b(t,"name");var n=new Enum(t);x(n,function(e){switch(e){case"option":F(n,e),d(";");break;case"reserved":g(n.reserved||(n.reserved=[]),!0);break;default:(function(e,t){if(!nameRe.test(t))throw b(t,"name");d("=");var n=q(u(),!0),r={options:void 0};r.setOption=function(e,t){void 0===this.options&&(this.options={}),this.options[e]=t},x(r,function(e){if("option"===e)F(r,e),d(";");else throw b(e)},function(){$(r)}),e.add(t,n,r.comment,r.options)})(n,e)}}),e.add(n)}function F(e,t){var n,a,o,i,s,f=d("(",!0);if(!typeRefRe.test(t=u()))throw b(t,"name");var c=t,p=c;f&&(d(")"),p=c="("+c+")",t=l(),fqTypeRefRe.test(t)&&(s=t.slice(1),c+=t,u())),d("=");var h=function e(t,n){if(d("{",!0)){for(var a={};!d("}",!0);){if(!nameRe.test(r=u()))throw b(r,"name");if(null===r)throw b(r,"end of input");var o,i,s=r;if(d(":",!0),"{"===l())o=e(t,n+"."+r);else if("["===l()){if(o=[],d("[",!0)){do i=y(!0),o.push(i);while(d(",",!0));d("]"),void 0!==i&&z(t,n+"."+r,i)}}else o=y(!0),z(t,n+"."+r,o);var f=a[s];f&&(o=[].concat(f).concat(o)),a[s]=o,d(",",!0),d(";",!0)}return a}var c=y(!0);return z(t,n,c),c}(e,c);n=e,a=p,o=h,i=s,n.setParsedOption&&n.setParsedOption(a,o,i)}function z(e,t,n){e.setOption&&e.setOption(t,n)}function $(e){if(d("[",!0)){do F(e,"option");while(d(",",!0));d("]")}return e}for(;null!==(r=u());)switch(r){case"package":if(!m)throw b(r);!function(){if(void 0!==a)throw b("package");if(a=u(),!typeRefRe.test(a))throw b(a,"name");v=v.define(a),d(";")}();break;case"import":if(!m)throw b(r);!function(){var e,t=l();switch(t){case"weak":e=i||(i=[]),u();break;case"public":u();default:e=o||(o=[])}t=k(),d(";"),e.push(t)}();break;case"syntax":if(!m)throw b(r);!function(){if(d("="),!(w="proto3"===(s=k()))&&"proto2"!==s)throw b(s,"syntax");d(";")}();break;case"option":F(v,r),d(";");break;default:if(A(v,r)){m=!1;continue}throw b(r)}return parse.filename=null,{package:a,imports:o,weakImports:i,syntax:s,root:t}}